<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" 
			   creationComplete="creationCompleteHandler(event)" 
			   title="Pesquisa de Etiqueta Vitrine" 
			   xmlns:visual="br.com.desenv.framework.component.visual.*"
			   maxWidth="1200" maxHeight="700" 
			    xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="EtiquetaVitrineSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.EtiquetaVitrine;

			import br.com.desenv.nepalign.vo.EmpresaFisica;
			
			[Bindable]
			public var listaEtiquetaVitrine: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			
			[Bindable]
			private var listaEmpresaFisicaPesquisa: ArrayCollection = new ArrayCollection();

			
			private var etiquetaVitrineComponenteDetalhe: EtiquetaVitrineComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): EtiquetaVitrine
			{
				var etiquetaVitrineFiltro: EtiquetaVitrine = new EtiquetaVitrine();
				
				etiquetaVitrineFiltro.descricao = ignTextInputDescricaoPesquisa.text == ""?null:ignTextInputDescricaoPesquisa.text;
				etiquetaVitrineFiltro.empresaFisica = ignComboBoxAutoCompleteEmpresaFisicaPesquisa.selectedItem; 
				etiquetaVitrineFiltro.nomeMetodo = ignTextInputNomeMetodoPesquisa.text == ""?null:ignTextInputNomeMetodoPesquisa.text;
				return etiquetaVitrineFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	
				
				var remoteObjectEmpresaFisica: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("empresaFisicaService", listarEmpresaFisicaPesquisaResultHandler);	
				remoteObjectEmpresaFisica.getOperation("listar").send();
				
				var etiquetaVitrineFiltro: EtiquetaVitrine = new EtiquetaVitrine();
				remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, etiquetaVitrineFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaEtiquetaVitrine: Page = event.result as Page;
				pageNumber = paginaEtiquetaVitrine.pageNumber;
				totalRecords = paginaEtiquetaVitrine.totalRecords;
				lastPage = paginaEtiquetaVitrine.lastPage();
				listaEtiquetaVitrine = paginaEtiquetaVitrine.recordList;
				labelPaginaAtual.text = "" + paginaEtiquetaVitrine.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaEtiquetaVitrine.totalRecords;
			}

// CARREGANDO COMBOS			
			private function listarEmpresaFisicaPesquisaResultHandler( event: ResultEvent ): void 
			{
				listaEmpresaFisicaPesquisa = event.result as ArrayCollection;
				listaEmpresaFisicaPesquisa.addItemAt(null, 0);
			}

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	
					remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var etiquetaVitrineComponenteCadastro: EtiquetaVitrineComponenteCadastro = new EtiquetaVitrineComponenteCadastro();
				etiquetaVitrineComponenteCadastro.etiquetaVitrine = new EtiquetaVitrine(); 
				etiquetaVitrineComponenteCadastro.addEventListener("EtiquetaVitrineIncluidoEvent", atualizarListaEtiquetaVitrinePorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(etiquetaVitrineComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(etiquetaVitrineComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var etiquetaVitrineSelecionado: EtiquetaVitrine = datagridListaEtiquetaVitrine.selectedItem as EtiquetaVitrine;
				this.dispatchEvent(new ResultEvent("EtiquetaVitrineSelecionadoEvent",false, true, etiquetaVitrineSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaEtiquetaVitrine_doubleClickHandler(event:MouseEvent):void
			{
				etiquetaVitrineComponenteDetalhe = new EtiquetaVitrineComponenteDetalhe();
				etiquetaVitrineComponenteDetalhe.etiquetaVitrine = datagridListaEtiquetaVitrine.selectedItem as EtiquetaVitrine;
				etiquetaVitrineComponenteDetalhe.addEventListener("EtiquetaVitrineExcluidoEvent", atualizarListaEtiquetaVitrinePorExclusaoResultHandler);
				etiquetaVitrineComponenteDetalhe.addEventListener("EtiquetaVitrineAtualizadoEvent", atualizarListaEtiquetaVitrinePorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(etiquetaVitrineComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(etiquetaVitrineComponenteDetalhe);
			}
			
			
			private function atualizarListaEtiquetaVitrinePorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	
				remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaEtiquetaVitrinePorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	
				remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaEtiquetaVitrinePorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	
				remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	
				remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectEtiquetaVitrine: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("etiquetaVitrineService", listarResultHandler);	
				remoteObjectEtiquetaVitrine.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
			
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Descrição:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricaoPesquisa" styleName="labelValidacao" text="{ignTextInputDescricaoPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricaoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Eempresa Fisica:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoEmpresaFisicaPesquisa" styleName="labelValidacao" text="{ignComboBoxAutoCompleteEmpresaFisicaPesquisa.errorString}"/>
					<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteEmpresaFisicaPesquisa" dataProvider="{listaEmpresaFisicaPesquisa}" labelField="razaoSocial" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>		


		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Nome Metodo:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNomeMetodoPesquisa" styleName="labelValidacao" text="{ignTextInputNomeMetodoPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputNomeMetodoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaEtiquetaVitrine"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaEtiquetaVitrine}" doubleClick="datagridListaEtiquetaVitrine_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="descricao" headerText="Descrição" resizable="true"/>
						<mx:DataGridColumn dataField="empresaFisica.razaoSocial" headerText="Eempresa Fisica" resizable="true"/>
						<mx:DataGridColumn dataField="nomeMetodo" headerText="Nome Metodo" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
